let sslide = {
  /* (A) ИНИЦИАЛИЗАЦИЯ - ПРЕДВАРИТЕЛЬНАЯ ЗАГРУЗКА ИЗОБРАЖЕНИЙ */
  instances : [],
  init : (opt) => {
    // (A1) ЗАРЕГИСТРИРОВАТЬ ЭКЗЕМПЛЯР СЛАЙД-ШОУ
    const id = sslide.instances.length;
    sslide.instances.push(opt);

    // (A2) ПРЕДВАРИТЕЛЬНАЯ ЗАГРУЗКА ИЗОБРАЖЕНИЙ
    let loaded = 0, ready = () => {
      loaded++;
      if (loaded == opt.images.length) { sslide.attach(id); }
    };
    for (let i of opt.images) {
      let img = new Image();
      img.src = i.src;
      img.onload = ready;
    }
  },

  /* (B) ИНИЦИАЛИЗАЦИЯ - ПРИСОЕДИНЕНИЕ HTML-ЭЛЕМЕНТОВ */
  attach : (id) => {
    // (B1) ПОЛУЧИТЬ HTML-КОНТЕЙНЕР
    let inst = sslide.instances[id],
        sSlide = document.getElementById(inst.target);

    // (B2) СЛАЙДШОУ HTML ИНТЕРФЕЙС
    let sImg = document.createElement("img"),
        sCaption = document.createElement("div"),
        sLeft = document.createElement("div"),
        sRight = document.createElement("div");
    sSlide.className = "sSlide";
    sImg.className = "sImg";
    sCaption.className = "sCaption";
    sLeft.className = "sLeft";
    sRight.className = "sRight";
    sLeft.innerHTML = "<";
    sRight.innerHTML = ">";
    sLeft.addEventListener("click", () => { sslide.nav(id, 0); });
    sRight.addEventListener("click", () => { sslide.nav(id, 1); });
    sSlide.appendChild(sImg);
    sSlide.appendChild(sCaption);
    sSlide.appendChild(sLeft);
    sSlide.appendChild(sRight);

    // (B3) ГОТОВЫ!
    inst.current = -1;
    inst.sImg = sImg;
    inst.sCaption = sCaption;
    sslide.nav(id, 1);
  },

  /* (C) НАВИГАЦИЯ */
  nav : (id, direction) => {
    // (C1) РАССЧИТАТЬ СЛЕДУЮЩИЙ СЛАЙД
    let inst = sslide.instances[id],
        slides = inst.images;
    if (direction) { inst.current++; }
    else { inst.current--; }
    if (inst.current < 0) { inst.current = slides.length - 1; }
    if (inst.current >= slides.length) { inst.current = 0; }

    // (C2) ВЫВЕСТИ СЛАЙД
    inst.sImg.src = slides[inst.current].src;
    inst.sCaption.innerHTML = slides[inst.current].cap;

    // (C3) АВТОМАТИЧЕСКИЙ РЕЖИМ ПРОКРУТКИ
    if (inst.auto) {
      if (inst.timer) { clearInterval(inst.timer); }
      inst.timer = setInterval(() => { sslide.nav(id, 1); }, inst.auto);
    }
  }
};
